Index: issm/trunk/src/c/classes/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Penta.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Penta.cpp	(revision 27232)
@@ -2604,5 +2604,5 @@
 	this->AddInput(enum_type,values,this->element_type);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(values);
 	xDelete<int>(doflist);
@@ -2645,5 +2645,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(doflist);
 }
@@ -2699,5 +2699,5 @@
 			inputs->SetPentaInput(name,P1Enum,NUMVERTICES,lidlist,values);
 
-			/*Free ressources:*/
+			/*Free resources:*/
 			xDelete<int>(doflist);
 			return;
@@ -2712,5 +2712,5 @@
 			inputs->SetPentaInput(name,P1Enum,NUMVERTICES,lidlist,values);
 
-			/*Free ressources:*/
+			/*Free resources:*/
 			xDelete<int>(doflist);
 			return;
Index: issm/trunk/src/c/classes/Elements/Penta.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Penta.h	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Penta.h	(revision 27232)
@@ -227,5 +227,5 @@
 		void       SealevelchangeGeometrySubElementKernel(SealevelGeometry* slgeom){_error_("not implemented yet");};
 		void       SealevelchangeShift(GrdLoads* loads,  IssmDouble offset, SealevelGeometry* slgeom){_error_("not implemented yet");};
-		void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae){_error_("not implemented yet");};
+		void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae, int* lids){_error_("not implemented yet");};
 		void       SealevelchangeGeometryCentroidLoads(SealevelGeometry* slgeom, IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae){_error_("not implemented yet");};
 		void       SealevelchangeGeometrySubElementLoads(SealevelGeometry* slgeom, IssmDouble* areae){_error_("not implemented yet");};
Index: issm/trunk/src/c/classes/Elements/Seg.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Seg.h	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Seg.h	(revision 27232)
@@ -180,5 +180,5 @@
 		void       SealevelchangeGeometrySubElementKernel(SealevelGeometry* slgeom){_error_("not implemented yet");};
 		void       SealevelchangeShift(GrdLoads* loads, IssmDouble offset, SealevelGeometry* slgeom){_error_("not implemented yet");};
-		void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae){_error_("not implemented yet");};
+		void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae, int* lids){_error_("not implemented yet");};
 		void       SealevelchangeGeometryCentroidLoads(SealevelGeometry* slgeom, IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae){_error_("not implemented yet");};
 		void       SealevelchangeGeometrySubElementLoads(SealevelGeometry* slgeom, IssmDouble* areae){_error_("not implemented yet");};
Index: issm/trunk/src/c/classes/Elements/Tetra.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tetra.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Tetra.cpp	(revision 27232)
@@ -446,5 +446,5 @@
 	this->AddInput(enum_type,values,this->element_type);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(values);
 	xDelete<int>(doflist);
Index: issm/trunk/src/c/classes/Elements/Tetra.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Tetra.h	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Tetra.h	(revision 27232)
@@ -187,5 +187,5 @@
 		void       SealevelchangeGeometrySubElementKernel(SealevelGeometry* slgeom){_error_("not implemented yet");};
 		void       SealevelchangeShift(GrdLoads* loads,  IssmDouble offset, SealevelGeometry* slgeom){_error_("not implemented yet");};
-		void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae){_error_("not implemented yet");};
+		void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae, int* lids){_error_("not implemented yet");};
 		void       SealevelchangeGeometryCentroidLoads(SealevelGeometry* slgeom, IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae){_error_("not implemented yet");};
 		void       SealevelchangeGeometrySubElementLoads(SealevelGeometry* slgeom, IssmDouble* areae){_error_("not implemented yet");};
Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 27232)
@@ -376,4 +376,5 @@
 	IssmDouble  time;
 	IssmDouble  coeff, indrate;
+	IssmDouble  bed, bedrate = 1.0;
 
 	/*Retrieve all inputs and parameters we will need*/
@@ -382,4 +383,5 @@
 	parameters->FindParam(&indrate,CalvingTestIndependentRateEnum,time);
 
+	Input *bs_input = this->GetInput(BedEnum);_assert_(bs_input);
 	Input* vx_input = this->GetInput(VxEnum); _assert_(vx_input);
 	Input* vy_input = this->GetInput(VyEnum); _assert_(vy_input);
@@ -399,9 +401,12 @@
       lsf_slopey_input->GetInputValue(&dphidy,&gauss);
 
+		bs_input->GetInputValue(&bed,&gauss);
+		bedrate = (bed>0)?0.0:1.0;
+
       vel=sqrt(vx*vx + vy*vy) + 1e-14;
       dphi=sqrt(dphidx*dphidx+dphidy*dphidy)+ 1e-14;
 
-		calvingratex[iv]= coeff*vx + indrate*dphidx/dphi;
-		calvingratey[iv]= coeff*vy + indrate*dphidy/dphi;
+		calvingratex[iv]= coeff*vx + bedrate*indrate*dphidx/dphi;
+		calvingratey[iv]= coeff*vy + bedrate*indrate*dphidy/dphi;
 		calvingrate[iv] = sqrt(calvingratex[iv]*calvingratex[iv] + calvingratey[iv]*calvingratey[iv]);
 	}
@@ -835,10 +840,10 @@
 	IssmDouble  lambda1,lambda2,ex,ey,vx,vy,vel;
 	IssmDouble  sigma_vm[NUMVERTICES];
-	IssmDouble  B,sigma_max,sigma_max_floating,sigma_max_grounded,n;
+	IssmDouble  B, n;
 	IssmDouble  epse_2,groundedice,bed,sealevel;
-	IssmDouble  arate, rho_ice, rho_water, thickness, paramX, Hab;
-	int			use_parameter=0;
-	int			nonlinear_law=0;
-	IssmDouble  theta, alpha, midp, gamma;
+	IssmDouble  arate, rho_ice, rho_water, thickness;
+	int			use_parameter=-1;
+	IssmDouble  gamma, theta, alpha, xoffset, yoffset;
+	IssmDouble  vel_lower, vel_upper, vrate, truncateVrate;
 
 	/* Get node coordinates and dof list: */
@@ -852,6 +857,4 @@
 	Input *bs_input      = this->GetInput(BedEnum);                               _assert_(bs_input);
 	Input *H_input       = this->GetInput(ThicknessEnum);                         _assert_(H_input);
-	Input *smax_fl_input = this->GetInput(CalvingStressThresholdFloatingiceEnum); _assert_(smax_fl_input);
-	Input *smax_gr_input = this->GetInput(CalvingStressThresholdGroundediceEnum); _assert_(smax_gr_input);
 	Input *n_input       = this->GetInput(MaterialsRheologyNEnum);                _assert_(n_input);
 	Input *sl_input      = this->GetInput(SealevelEnum);                          _assert_(sl_input);
@@ -864,8 +867,10 @@
 	/* Use which parameter  */
 	this->FindParam(&use_parameter, CalvingUseParamEnum);
-	this->FindParam(&theta, CalvingScaleThetaEnum);
-	this->FindParam(&alpha, CalvingAmpAlphaEnum);
-	this->FindParam(&midp, CalvingMidpointEnum);
-	this->FindParam(&nonlinear_law, CalvingNonlinearLawEnum);
+	this->FindParam(&theta, CalvingThetaEnum);
+	this->FindParam(&alpha, CalvingAlphaEnum);
+	this->FindParam(&xoffset, CalvingXoffsetEnum);
+	this->FindParam(&yoffset, CalvingYoffsetEnum);
+	this->FindParam(&vel_lower, CalvingVelLowerboundEnum);
+	this->FindParam(&vel_upper, CalvingVelUpperboundEnum);
 
 	/* Start looping on the number of vertices: */
@@ -882,9 +887,9 @@
 		bs_input->GetInputValue(&bed,gauss);
 		H_input->GetInputValue(&thickness,gauss);
-		smax_fl_input->GetInputValue(&sigma_max_floating,gauss);
-		smax_gr_input->GetInputValue(&sigma_max_grounded,gauss);
 		vel=sqrt(vx*vx+vy*vy)+1.e-14;
 		sl_input->GetInputValue(&sealevel,gauss);
 		arate_input->GetInputValue(&arate,gauss);
+		vrate = 1.0;
+		if (vel < vel_upper) vrate = vel / vel_upper;
 
 		/*Compute strain rate and viscosity: */
@@ -904,30 +909,30 @@
 		sigma_vm[iv]  = sqrt(3.) * B * pow(epse_2,1./(2.*n));
 
-		/*Tensile stress threshold*/
-		if(groundedice<0)
-		 sigma_max = sigma_max_floating;
-		else
-		 sigma_max = sigma_max_grounded;
-
 		switch (use_parameter) { 
 			case 0:
-				/* bed elevation */
-				paramX = bed;
+				/* 0 Linear: f(x) = y_{o} + \alpha (x+x_{o}) */
+				gamma = yoffset = alpha * (bed+xoffset);
 				break;
 			case 1:
-				/* Height above floatation */
-				if (bed>sealevel)	paramX = 0.0;
-				else paramX = thickness - (rho_water/rho_ice) * (sealevel-bed);
+				/* 1 tanh: f(x)=y_{o}-\frac{\theta}{2}\tanh(\alpha(x+x_{o})) */
+				gamma = yoffset -  0.5*theta*tanh(alpha*(bed+xoffset));
 				break;
 			case 2:
-				/* Thicknese */
-				paramX = thickness;
+				/* 2 tanh(thicknes): f(x)=y_{o}-\frac{\theta}{2}\tanh(\alpha(x+x_{o})) */
+				gamma = yoffset -  0.5*theta*tanh(alpha*(-thickness+xoffset));
+				break;
+			case 3:
+				/* 3 tanh(normal vel): f(x)=y_{o}-\frac{\theta}{2}\tanh(\alpha(x+x_{o})) */
+				_error_("The normalized velocity is not supported yet!");
+				gamma = yoffset -  0.5*theta*tanh(alpha*(vel+xoffset));
 				break;
 			case 4:
-				/* bed elevation+linear curve fitting */
-				paramX = bed;
+				/* 4 tanh(truncated vel): f(x)=y_{o}-\frac{\theta}{2}\tanh(\alpha(x+x_{o})) */
+				truncateVrate = (min(vel_upper, max(vel_lower, vel))-vel_lower) / vel_upper;
+				gamma = 0.5*theta*(tanh(alpha*xoffset) - tanh(alpha*(truncateVrate+xoffset)));
 				break;
 			case -1:
-				/* use nothing, just the arate*/
+				/* nothing, just the arate*/
+				gamma = 1;
 				break;
 			default:
@@ -935,32 +940,17 @@
 		}
 
-		/* Compute the hyperbolic tangent function */
-		if ((use_parameter>-0.5) & (use_parameter<3)) {
-			gamma = 0.5*theta*(1.0-tanh((paramX+midp)/alpha))+(1.0-theta);
-			if (gamma<0.0) gamma =0.0;
-		}
-		else if (use_parameter>=3) {
-			gamma = alpha*paramX + theta;
-			if (gamma > 1.0) gamma = 1.0;
-			if (gamma < 0.0) gamma = 0.0;
-		}
-		else gamma = 1;
+		/* set upper and lower bounds */
+		if (gamma > 1.0) gamma = 1.0;
+		if (gamma < 0.0) gamma = 0.0;
+		if (bed >= sealevel) gamma = 0.0;
 
 		/*-------------------------------------------*/
-		if (nonlinear_law) {
-			/*This von Mises type has too strong positive feedback with vel included
-			 * calvingrate[iv] = (arate+sigma_vm[iv]*vel/sigma_max)*gamma;
-			 */
-			Hab = thickness - (rho_water/rho_ice) * (sealevel-bed);
-			if (Hab < 0.) Hab = 0.;
-			if (bed > sealevel) Hab = 0.;
-
-			calvingrate[iv] = (arate+Hab/sigma_max)*gamma;
-		}
+		if (use_parameter < 3) {
+			calvingrate[iv] = arate*gamma*vrate;
+		} 
 		else {
 			calvingrate[iv] = arate*gamma;
 		}
 	}
-
 	/*Add input*/
 	this->AddInput(CalvingCalvingrateEnum,&calvingrate[0],P1DGEnum);
@@ -2018,5 +2008,5 @@
 	else for(int i=0;i<NUMVERTICES;i++)weights[i]=0;
 
-	/*free ressources:*/
+	/*Free resources:*/
 	delete gauss;
 
@@ -3905,5 +3895,5 @@
 	this->AddInput(enum_type,values,this->element_type);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(values);
 	xDelete<int>(doflist);
@@ -6044,5 +6034,5 @@
 	pY->SetValues(gsize,indices,Y_values,ADD_VAL);
 
-	/*free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(indices);
 	xDelete<IssmDouble>(U_values); xDelete<IssmDouble>(N_values); xDelete<IssmDouble>(E_values);
@@ -6206,5 +6196,5 @@
 	pEast->SetValues(gsize,indices,E_values,ADD_VAL);
 
-	/*free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(indices);
 	xDelete<IssmDouble>(U_values); xDelete<IssmDouble>(N_values); xDelete<IssmDouble>(E_values);
@@ -6313,5 +6303,5 @@
 	}
 
-	/*Free ressources: */
+	/*Free resources: */
 	xDelete<IssmDouble>(hes);
 	xDelete<IssmDouble>(times);
@@ -6320,5 +6310,5 @@
 }
 /*}}}*/
-void       Tria::SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae){ /*{{{*/
+void       Tria::SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae, int* lids){ /*{{{*/
 
 	/*Declarations:{{{*/
@@ -6342,21 +6332,7 @@
 
 	#ifdef _HAVE_RESTRICT_
-	IssmDouble* __restrict__ G=NULL;
-	IssmDouble* __restrict__ GU=NULL;
-	IssmDouble* __restrict__ GN=NULL;
-	IssmDouble* __restrict__ GE=NULL;
-	IssmDouble* __restrict__ G_viscoelastic_precomputed=NULL;
 	IssmDouble* __restrict__ G_gravi_precomputed=NULL;
-	IssmDouble* __restrict__ U_viscoelastic_precomputed=NULL;
-	IssmDouble* __restrict__ H_viscoelastic_precomputed=NULL;
 	#else
-	IssmDouble* G=NULL;
-	IssmDouble* GU=NULL;
-	IssmDouble* GN=NULL;
-	IssmDouble* GE=NULL;
-	IssmDouble* G_viscoelastic_precomputed=NULL;
 	IssmDouble* G_gravi_precomputed=NULL;
-	IssmDouble* U_viscoelastic_precomputed=NULL;
-	IssmDouble* H_viscoelastic_precomputed=NULL;
 	#endif
 
@@ -6364,4 +6340,5 @@
 	int index;
 	int M;
+	IssmDouble degacc;
 	IssmDouble doubleindex,lincoef;
 
@@ -6380,4 +6357,8 @@
 	/*Rotational:*/
 	#ifdef _HAVE_RESTRICT_
+	IssmDouble* __restrict__ Grot=NULL;
+	IssmDouble* __restrict__ GUrot=NULL;
+	IssmDouble* __restrict__ GNrot=NULL;
+	IssmDouble* __restrict__ GErot=NULL;
 	IssmDouble* __restrict__ tide_love_h  = NULL;
 	IssmDouble* __restrict__ tide_love_k  = NULL;
@@ -6386,9 +6367,11 @@
 	IssmDouble* __restrict__ LoveRotU     = NULL;
 	IssmDouble* __restrict__ LoveRothoriz = NULL;
-	IssmDouble* __restrict__  Grot        = NULL;
-	IssmDouble* __restrict__ GUrot        = NULL;
-	IssmDouble* __restrict__ GNrot        = NULL;
-	IssmDouble* __restrict__ GErot        = NULL;
+	int* __restrict__ AplhaIndex   = NULL;
+	int* __restrict__ AzimuthIndex = NULL;
 	#else
+	IssmDouble* Grot=NULL;
+	IssmDouble* GUrot=NULL;
+	IssmDouble* GNrot=NULL;
+	IssmDouble* GErot=NULL;
 	IssmDouble* tide_love_h  = NULL;
 	IssmDouble* tide_love_k  = NULL;
@@ -6397,8 +6380,6 @@
 	IssmDouble* LoveRotU     = NULL;
 	IssmDouble* LoveRothoriz = NULL;
-	IssmDouble*  Grot        = NULL;
-	IssmDouble* GUrot        = NULL;
-	IssmDouble* GNrot        = NULL;
-	IssmDouble* GErot        = NULL;
+	int* AlphaIndex   = NULL;
+	int* AzimuthIndex = NULL;
 	#endif
 
@@ -6439,19 +6420,9 @@
 
 	/*Recover precomputed green function kernels:{{{*/
-	DoubleVecParam* parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGSelfAttractionEnum)); _assert_(parameter);
-	parameter->GetParameterValueByPointer((IssmDouble**)&G_gravi_precomputed,&M);
-
+	parameters->FindParam(&degacc,SolidearthSettingsDegreeAccuracyEnum);
+	M=reCast<int,IssmDouble>(180.0/degacc+1.);
+
+	DoubleVecParam* parameter;
 	if(computeelastic){
-		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGViscoElasticEnum)); _assert_(parameter);
-		parameter->GetParameterValueByPointer((IssmDouble**)&G_viscoelastic_precomputed,NULL);
-
-		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeUViscoElasticEnum)); _assert_(parameter);
-		parameter->GetParameterValueByPointer((IssmDouble**)&U_viscoelastic_precomputed,NULL);
-
-		if(horiz){
-			parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeHViscoElasticEnum)); _assert_(parameter);
-			parameter->GetParameterValueByPointer((IssmDouble**)&H_viscoelastic_precomputed,NULL);
-		}
-
 		if(computerotation){
 			parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeTidalH2Enum)); _assert_(parameter);
@@ -6489,92 +6460,45 @@
 	}
 
-	constant=3/rho_earth/planetarea;
-
-	G=xNewZeroInit<IssmDouble>(3*nel*nt);
-	if(computeelastic){
-		GU=xNewZeroInit<IssmDouble>(3*nel*nt);
-		if(horiz){
-			GN=xNewZeroInit<IssmDouble>(3*nel*nt);
-			GE=xNewZeroInit<IssmDouble>(3*nel*nt);
-		}
-	}
-
-	for(int e=0;e<nel;e++){
-		ratioe=constant*areae[e];
-		for (int i=0;i<3;i++){
-			IssmDouble alpha;
-			IssmDouble delPhi,delLambda;
-			/*recovers info for this element and vertex:*/
-			IssmDouble late= asin(zze[e]/sqrt( pow(xxe[e],2.0)+ pow(yye[e],2.0)+ pow(zze[e],2.0)));
-			IssmDouble longe= atan2(yye[e],xxe[e]);
-
-			lati=latitude[i];
-			longi=longitude[i];
-
-			/*Computes alpha angle between centroid and current vertex, and indexes alpha in precomputed tables: */
-			delPhi=fabs(lati-late); delLambda=fabs(longi-longe); if (delLambda>M_PI)delLambda=2*M_PI-delLambda;
-			alpha=2.*asin(sqrt(pow(sin(delPhi/2),2)+cos(lati)*cos(late)*pow(sin(delLambda/2),2)));
-			doubleindex=alpha/M_PI*reCast<IssmDouble,int>(M-1); //maps 0<alpha<PI on [0:M-1]
-			index=reCast<int,IssmDouble>(doubleindex); //truncates doubleindex to integer part
-			_assert_(index>=0 && index<M);
-
-			lincoef=doubleindex-index; //where between index and index+1 is alpha
-			if (index==M-1){ //avoids out of bound case
-				index-=1;
-				lincoef=1;
-			}
-
-			if(horiz){
-				/*Compute azimuths, both north and east components: */
-				x = xyz_list[i][0]; y = xyz_list[i][1]; z = xyz_list[i][2];
-				if(lati==M_PI/2){
-					x=1e-12; y=1e-12;
+	AlphaIndex=xNewZeroInit<int>(3*nel);
+	if (horiz) AzimuthIndex=xNewZeroInit<int>(3*nel);
+	int intmax=pow(2,16)-1;
+
+
+	for (int i=0;i<3;i++){
+		if(lids[this->vertices[i]->lid]==this->lid){
+			for(int e=0;e<nel;e++){
+				IssmDouble alpha;
+				IssmDouble delPhi,delLambda;
+				/*recovers info for this element and vertex:*/
+				IssmDouble late= asin(zze[e]/sqrt( pow(xxe[e],2.0)+ pow(yye[e],2.0)+ pow(zze[e],2.0)));
+				IssmDouble longe= atan2(yye[e],xxe[e]);
+
+				lati=latitude[i];
+				longi=longitude[i];
+
+				/*Computes alpha angle between centroid and current vertex, and indexes alpha in precomputed tables: */
+				delPhi=fabs(lati-late); delLambda=fabs(longi-longe); if (delLambda>M_PI)delLambda=2*M_PI-delLambda;
+				alpha=2.*asin(sqrt(pow(sin(delPhi/2),2)+cos(lati)*cos(late)*pow(sin(delLambda/2),2)));
+				doubleindex=alpha/M_PI*reCast<IssmDouble,int>(M-1); //maps 0<alpha<PI on [0:M-1]
+				index=reCast<int,IssmDouble>(doubleindex); //truncates doubleindex to integer part
+				if ((doubleindex-index)>=0.5) index+=1; //nearest neighbour
+				_assert_(index>=0 && index<M);
+
+				if(horiz){
+					/*Compute azimuths*/
+					dx=cos(lati)*sin(late)-sin(lati)*cos(late)*cos(longe-longi);
+					dy=sin(longe-longi)*cos(late);
+					//angle between horiz motion and North, remapped from a double on [0,2*pi] to a int [0,intmax]
+					AzimuthIndex[i*nel+e]=reCast<int,IssmDouble>(intmax*(atan2(dy,dx)/2/M_PI));
 				}
-				if(lati==-M_PI/2){
-					x=1e-12; y=1e-12;
-				}
-				dx = xxe[e]-x; dy = yye[e]-y; dz = zze[e]-z;
-				N_azim = (-z*x*dx-z*y*dy+(pow(x,2)+pow(y,2))*dz) /pow((pow(x,2)+pow(y,2))*(pow(x,2)+pow(y,2)+pow(z,2))*(pow(dx,2)+pow(dy,2)+pow(dz,2)),0.5);
-				E_azim = (-y*dx+x*dy) /pow((pow(x,2)+pow(y,2))*(pow(dx,2)+pow(dy,2)+pow(dz,2)),0.5);
-			}
-
-			for(int t=0;t<nt;t++){
-				int timeindex=i*nel*nt+e*nt+t; 
-
-				/*Rigid earth gravitational perturbation: */
-				G[timeindex]+=G_gravi_precomputed[index+0]*(1.-lincoef) 
-					     +G_gravi_precomputed[index+1]*lincoef; //linear interpolation
-
-				/*Find a way to interpolate precomputed Gkernels to our solution time stepping:*/
-				if(computeelastic){
-					G[timeindex]+=G_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
-						     +G_viscoelastic_precomputed[(index+1)*nt+t]*lincoef; //linear interpolation
-				}
-				G[timeindex]=G[timeindex]*ratioe;
-
-				/*Elastic components:*/
-				if(computeelastic){
-					GU[timeindex] =  ratioe *(U_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
-								 +U_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
-					if(horiz){
-						GN[timeindex] = N_azim*ratioe *(H_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
-								 	       +H_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
-						GE[timeindex] = E_azim*ratioe *(H_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
-								 	       +H_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
-					}
-				}
-			} //for(int t=0;t<nt;t++)
+				AlphaIndex[i*nel+e]=index;
+			}			
 		} //for (int i=0;i<3;i++)
 	} //for(int e=0;e<nel;e++)
 
 	/*Add in inputs:*/
-	this->inputs->SetArrayInput(SealevelchangeGEnum,this->lid,G,nel*3*nt);
-	if(computeelastic){
-		this->inputs->SetArrayInput(SealevelchangeGUEnum,this->lid,GU,nel*3*nt);
-		if(horiz){
-			this->inputs->SetArrayInput(SealevelchangeGNEnum,this->lid,GN,nel*3*nt);
-			this->inputs->SetArrayInput(SealevelchangeGEEnum,this->lid,GE,nel*3*nt);
-		}
-	}
+	this->inputs->SetIntArrayInput(SealevelchangeAlphaIndexEnum,this->lid,AlphaIndex,nel*3);
+	if(horiz) this->inputs->SetIntArrayInput(SealevelchangeAzimuthIndexEnum,this->lid,AzimuthIndex,nel*3);
+
 	/*}}}*/
 	/*Compute rotation kernel:{{{*/
@@ -6583,5 +6507,5 @@
 		LoveRotRSL  = xNewZeroInit<IssmDouble>(nt);
 		LoveRotU    = xNewZeroInit<IssmDouble>(nt);
-		LoveRothoriz= xNewZeroInit<IssmDouble>(nt);
+		if(horiz)LoveRothoriz= xNewZeroInit<IssmDouble>(nt);
 		Grot        = xNewZeroInit<IssmDouble>(3*3*nt); //3 polar motion components * 3 vertices * number of time steps
 		GUrot       = xNewZeroInit<IssmDouble>(3*3*nt);
@@ -6669,4 +6593,8 @@
 			}
 		}
+		/*Free resources:*/
+		xDelete<IssmDouble>(LoveRotRSL);
+		xDelete<IssmDouble>(LoveRotU);
+		if(horiz)xDelete<IssmDouble>(LoveRothoriz);
 	}
 	/*}}}*/
@@ -6690,38 +6618,183 @@
 	/*Free allocations:{{{*/
 	#ifdef _HAVE_RESTRICT_
-	delete G;
-	if(computeelastic){
-		delete GU;
-		if(horiz){
-			delete GN;
-			delete GE;
-		}
-		if(computerotation){
-			delete Grot;
-			delete GUrot;
-			if (horiz){
-				delete GNrot;
-				delete GErot;
-			}
-		}
-	}
+	delete AlphaIndex;
+	if(horiz) AzimuthIndex;
+
+	if(computerotation){
+		delete Grot;
+		delete GUrot;
+		if (horiz){
+			delete GNrot;
+			delete GErot;
+		}
+	}
+
 	#else
-	xDelete(G);
-	if(computeelastic){
-		xDelete(GU);
-		if(horiz){
-			xDelete(GN);
-			xDelete(GE);
-		}
-		if(computerotation){
-			xDelete(Grot);
-			xDelete(GUrot);
-			if (horiz){
-				xDelete(GNrot);
-				xDelete(GErot);
-			}
+	xDelete<int>(AlphaIndex);
+	if(horiz){
+		xDelete<int>(AzimuthIndex);
+	}
+	if(computerotation){
+		xDelete<IssmDouble>(Grot);
+		xDelete<IssmDouble>(GUrot);
+		if (horiz){
+			xDelete<IssmDouble>(GNrot);
+			xDelete<IssmDouble>(GErot);
 		}
 	}
 	#endif
+	/*}}}*/
+	return;
+
+}
+/*}}}*/
+
+void       Tria::SealevelchangeGeometrySubElementKernel(SealevelGeometry* slgeom){ /*{{{*/
+
+	/*Declarations:{{{*/
+	int nel;
+	IssmDouble planetarea,planetradius;
+	IssmDouble constant,ratioe;
+	IssmDouble rho_earth;
+	IssmDouble lati,longi;
+	IssmDouble latitude[NUMVERTICES];
+	IssmDouble longitude[NUMVERTICES];
+	IssmDouble x,y,z,dx,dy,dz,N_azim,E_azim;
+	IssmDouble xyz_list[NUMVERTICES][3];
+
+	#ifdef _HAVE_RESTRICT_
+	int** __restrict__ AlphaIndex=NULL;
+	int** __restrict__ AzimIndex=NULL;
+
+	#else
+	int** AlphaIndex=NULL;
+	int** AzimIndex=NULL;
+	#endif
+
+	/*viscoelastic green function:*/
+	int index;
+	int M;
+	IssmDouble doubleindex,lincoef, degacc;
+
+	/*Computational flags:*/
+	bool computeselfattraction = false;
+	bool computeelastic = false;
+	bool computeviscous = false;
+	int  horiz;
+	int grd, grdmodel;
+
+	bool istime=true;
+	IssmDouble timeacc=0;
+	IssmDouble start_time,final_time;
+	int  nt,precomputednt;
+	int intmax=pow(2,16)-1;
+
+	/*}}}*/
+	/*Recover parameters:{{{ */
+	rho_earth=FindParam(MaterialsEarthDensityEnum);
+	this->parameters->FindParam(&computeselfattraction,SolidearthSettingsSelfAttractionEnum);
+	this->parameters->FindParam(&computeelastic,SolidearthSettingsElasticEnum);
+	this->parameters->FindParam(&computeviscous,SolidearthSettingsViscousEnum);
+	this->parameters->FindParam(&nel,MeshNumberofelementsEnum);
+	this->parameters->FindParam(&planetarea,SolidearthPlanetAreaEnum);
+	this->parameters->FindParam(&planetradius,SolidearthPlanetRadiusEnum);
+	this->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
+	this->parameters->FindParam(&grd,SolidearthSettingsGRDEnum); 
+	this->parameters->FindParam(&grdmodel,GrdModelEnum);
+	/*}}}*/
+
+	/*early return:*/
+	if (!grd || grdmodel!=ElasticEnum) return; //Love numbers won't be found in this case, return before loading them
+	if(!computeselfattraction)return;
+
+	/*Recover precomputed green function kernels:{{{*/
+	parameters->FindParam(&degacc,SolidearthSettingsDegreeAccuracyEnum);
+	M=reCast<int,IssmDouble>(180.0/degacc+1.);
+
+	/*}}}*/
+	/*Compute lat long of all vertices in the element:{{{*/
+	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
+	for(int i=0;i<NUMVERTICES;i++){
+		latitude[i]= asin(xyz_list[i][2]/planetradius);
+		longitude[i]= atan2(xyz_list[i][1],xyz_list[i][0]);
+	}
+	/*}}}*/
+	/*Compute green functions:{{{ */
+
+	if(computeviscous){
+		this->parameters->FindParam(&istime,LoveIsTimeEnum);
+		if(!istime)_error_("Frequency love numbers not supported yet!");
+		this->parameters->FindParam(&timeacc,SolidearthSettingsTimeAccEnum);
+		this->parameters->FindParam(&start_time,TimesteppingStartTimeEnum);
+		this->parameters->FindParam(&final_time,TimesteppingFinalTimeEnum);
+		nt=reCast<int,IssmDouble>((final_time-start_time)/timeacc)+1;
+	}
+	else{
+		nt=1; //in elastic, or if we run only selfattraction, we need only one step
+	}
+	AlphaIndex=xNew<int*>(SLGEOM_NUMLOADS);
+	if(horiz) AzimIndex=xNew<int*>(SLGEOM_NUMLOADS);
+
+
+	//Allocate: 
+	for(int l=0;l<SLGEOM_NUMLOADS;l++){
+		int nbar=slgeom->nbar[l];
+		AlphaIndex[l]=xNewZeroInit<int>(3*nbar);
+		if(horiz) AzimIndex[l]=xNewZeroInit<int>(3*nbar);
+
+
+		for (int i=0;i<3;i++){
+			if(slgeom->lids[this->vertices[i]->lid]==this->lid){
+				for(int e=0;e<nbar;e++){
+					IssmDouble alpha;
+					IssmDouble delPhi,delLambda;
+					/*recover info for this element and vertex:*/
+					IssmDouble late= slgeom->latbarycentre[l][e]; 
+					IssmDouble longe= slgeom->longbarycentre[l][e]; 
+					late=late/180*M_PI;
+					longe=longe/180*M_PI;
+
+					lati=latitude[i];
+					longi=longitude[i];
+
+					if(horiz){
+						/*Compute azimuths*/
+						dx=cos(lati)*sin(late)-sin(lati)*cos(late)*cos(longe-longi);
+						dy=sin(longe-longi)*cos(late);
+						//angle between horiz motion and North, remapped from a double on [0,2*pi] to a int [0,intmax]
+						AzimIndex[l][i*nbar+e]=reCast<int,IssmDouble>(intmax*(atan2(dy,dx)/2/M_PI));
+					}
+
+					/*Compute alpha angle between centroid and current vertex and index into precomputed tables: */
+					delPhi=fabs(lati-late); delLambda=fabs(longi-longe); if (delLambda>M_PI)delLambda=2*M_PI-delLambda;
+					alpha=2.*asin(sqrt(pow(sin(delPhi/2.0),2.0)+cos(lati)*cos(late)*pow(sin(delLambda/2.0),2.0)));
+					doubleindex=alpha/M_PI*reCast<IssmDouble,int>(M-1); //maps 0<alpha<PI on [0:M-1]
+					index=reCast<int,IssmDouble>(doubleindex); //truncates doubleindex to integer part
+
+					if ((doubleindex-index)>=0.5) index+=1; //nearest neighbour
+					if (index==M-1){ //avoids out of bound case
+						index-=1;
+						lincoef=1;
+					}
+					AlphaIndex[l][i*nbar+e]=index;
+				}
+			}
+		}
+	}
+
+	/*Save all these arrayins for each element:*/
+	for (int l=0;l<SLGEOM_NUMLOADS;l++){
+		this->inputs->SetIntArrayInput(slgeom->AlphaIndexEnum(l),this->lid,AlphaIndex[l],slgeom->nbar[l]*3);
+		if(horiz) this->inputs->SetIntArrayInput(slgeom->AzimuthIndexEnum(l),this->lid,AzimIndex[l],slgeom->nbar[l]*3);
+	}
+	/*}}}*/
+	/*Free memory:{{{*/
+	for (int l=0;l<SLGEOM_NUMLOADS;l++){
+		xDelete<int>(AlphaIndex[l]);
+		if(horiz) xDelete<int>(AzimIndex[l]);
+	}
+	xDelete<int*>(AlphaIndex);
+	if(horiz) xDelete<int*>(AzimIndex); 
+	
 	/*}}}*/
 	return;
@@ -6936,4 +7009,89 @@
 }
 /*}}}*/
+void       Tria::SealevelchangeBarystaticLoads(GrdLoads* loads,  BarystaticContributions* barycontrib, SealevelGeometry* slgeom){ /*{{{*/
+
+	int nel;
+
+	/*Inputs:*/
+	IssmDouble I[NUMVERTICES]; 
+	IssmDouble W[NUMVERTICES];
+	IssmDouble BP[NUMVERTICES];
+	IssmDouble* areae=NULL;
+
+	/*output: */
+	IssmDouble bslcice=0;
+	IssmDouble bslchydro=0;
+	IssmDouble bslcbp=0;
+	IssmDouble BPavg=0;
+	IssmDouble Iavg=0;
+	IssmDouble Wavg=0;
+
+	/*ice properties: */
+	IssmDouble rho_ice,rho_water,rho_freshwater;
+
+	/*recover some parameters:*/
+	this->parameters->FindParam(&rho_ice,MaterialsRhoIceEnum);
+	this->parameters->FindParam(&rho_water,MaterialsRhoSeawaterEnum);
+	this->parameters->FindParam(&rho_freshwater,MaterialsRhoFreshwaterEnum);
+	this->parameters->FindParam(&areae,&nel,AreaeEnum);
+
+	/*Retrieve inputs:*/
+	Element::GetInputListOnVertices(&I[0],DeltaIceThicknessEnum);
+	Element::GetInputListOnVertices(&W[0],DeltaTwsEnum);
+	Element::GetInputListOnVertices(&BP[0],DeltaBottomPressureEnum);
+
+	for(int i=0;i<NUMVERTICES;i++){
+		Iavg+=I[i]*slgeom->LoadWeigths[SLGEOM_ICE][i][this->lid]*slgeom->LoadArea[SLGEOM_ICE][this->lid];
+		Wavg+=W[i]*slgeom->LoadWeigths[SLGEOM_WATER][i][this->lid]*slgeom->LoadArea[SLGEOM_WATER][this->lid];
+		BPavg+=BP[i]*slgeom->LoadWeigths[SLGEOM_OCEAN][i][this->lid]*slgeom->LoadArea[SLGEOM_OCEAN][this->lid];
+	}
+
+	/*convert from m^3 to kg:*/
+	Iavg*=rho_ice;
+	Wavg*=rho_freshwater;
+	BPavg*=rho_water;
+
+	#ifdef _ISSM_DEBUG_ 
+	this->AddInput(SealevelBarystaticIceLoadEnum,&Iavg,P0Enum);
+	this->AddInput(SealevelBarystaticHydroLoadEnum,&Wavg,P0Enum);
+	this->AddInput(SealevelBarystaticBpLoadEnum,&BPavg,P0Enum);
+	#endif
+
+	/*Compute barystatic component in kg:*/
+	// Note: Iavg, etc, already include partial area factor phi for subelement loading
+	bslcice =   -Iavg;
+	bslchydro = -Wavg;
+	bslcbp =    -BPavg;
+
+	_assert_(!xIsNan<IssmDouble>(bslcice));
+	_assert_(!xIsNan<IssmDouble>(bslchydro));
+	_assert_(!xIsNan<IssmDouble>(bslcbp));
+
+	/*Plug values into subelement load vector:*/
+	if(slgeom->issubelement[SLGEOM_ICE][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_ICE][this->lid];
+		loads->vsubloads[SLGEOM_ICE]->SetValue(intj,Iavg,INS_VAL);
+		Iavg=0; //avoid double counting centroid loads and subelement loads!
+	}
+	if(slgeom->issubelement[SLGEOM_WATER][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_WATER][this->lid];
+		loads->vsubloads[SLGEOM_WATER]->SetValue(intj,Wavg,INS_VAL);
+		Wavg=0;
+	}
+	if(slgeom->issubelement[SLGEOM_OCEAN][this->lid]){
+		int intj=slgeom->subelementmapping[SLGEOM_OCEAN][this->lid];
+		loads->vsubloads[SLGEOM_OCEAN]->SetValue(intj,BPavg,INS_VAL); 
+		BPavg=0;
+	}
+	/*Plug remaining values into centroid load vector:*/
+	loads->vloads->SetValue(this->sid,Iavg+Wavg+BPavg,INS_VAL);
+
+	/*Keep track of barystatic contributions:*/
+	barycontrib->Set(this->Sid(),bslcice,bslchydro,bslcbp);
+
+	/*Free ressources*/
+	xDelete<IssmDouble>(areae);
+
+}/*}}}*/
 void       Tria::SealevelchangeGeometrySubElementLoads(SealevelGeometry* slgeom, IssmDouble* areae){ /*{{{*/
 
